-----

Documentation: [html](https://docs.ethers.io/)

-----

Constants
=========

Bytes
-----

#### *ethers* . *constants* . **AddressZero** => *string< [Address](/v5/api/utils/address/#address) >*

The Address Zero, which is 20 bytes (40 nibbles) of zero.


#### *ethers* . *constants* . **HashZero** => *string< [DataHexString](/v5/api/utils/bytes/#DataHexString)< 32 > >*

The Hash Zero, which is 32 bytes (64 nibbles) of zero.


Strings
-------

#### *ethers* . *constants* . **EtherSymbol** => *string*

The Ether symbol, **Xi**.


BigNumber
---------

#### *ethers* . *constants* . **NegativeOne** => *[BigNumber](/v5/api/utils/bignumber/)*

The BigNumber value representing `"-1"`.


#### *ethers* . *constants* . **Zero** => *[BigNumber](/v5/api/utils/bignumber/)*

The BigNumber value representing `"0"`.


#### *ethers* . *constants* . **One** => *[BigNumber](/v5/api/utils/bignumber/)*

The BigNumber value representing `"1"`.


#### *ethers* . *constants* . **Two** => *[BigNumber](/v5/api/utils/bignumber/)*

The BigNumber value representing `"2"`.


#### *ethers* . *constants* . **WeiPerEther** => *[BigNumber](/v5/api/utils/bignumber/)*

The BigNumber value representing `"1000000000000000000"`, which is the number of Wei per Ether.


#### *ethers* . *constants* . **MaxUint256** => *[BigNumber](/v5/api/utils/bignumber/)*

The BigNumber value representing the maximum `uint256` value.


